function [returnedData] = meanVariance(y, windowSize, minVariance)
    
    size = length(y);
   
    returnedData = zeros(size,1);
    means = zeros(size, 1);
    meanVar = zeros(size, 1);
   
    for i = ((windowSize/2)+1):(size - (windowSize/2))
        
        sum = 0;     
        
        for j = (i - (windowSize/2)):(i + (windowSize/2))
            
            sum = sum + y(j);
                        
        end
        
        mean = sum/(windowSize + 1);
       
        means(i) = mean; 
        
    end
    
     figure
     plot(1:length(means), means)
     legend('Mean calculated by meanVariance.m')
     xlabel('Time')
     ylabel('Mean')
 
     axis([0 length(means) -10 30])
    
    for i = (windowSize + 1):(size - windowSize)
    
        meanSum = 0;
        meanSumSecond = 0;
        
        for j = (i - (windowSize/2)):(i + (windowSize/2))
            
            meanSum = meanSum + means(j);
            meanSumSecond = meanSumSecond + ((means(j))^2);
            
        end
        
        meanMean = meanSum/(windowSize + 1);
        meanMeanSecond = meanSumSecond/(windowSize + 1);
        
        variance = meanMeanSecond - (meanMean^2);
        meanVar(i) = variance;        
        
        if(variance >= minVariance)
            
            window = (i - (windowSize/2)):(i+ (windowSize/2));
            returnedData(window) = 1;
        
        end 
        
    end
     figure
     plot(1:length(meanVar), meanVar)
     legend('Variance')
     xlabel('Time')
     ylabel('Variance calculated by meanVariance.m')
 
     axis([0 length(means) -10 30])
end









