function [sysIdSegmentU, sysIdSegmentY, valSegmentU, valSegmentY] = shdmi(u, y, windowSize, stepSize, minMeanChangeU, minMeanChangeY, minVarianceU, minVarianceY, minMeanVarU, minMeanVarY)

    size = length(u);

    firstCriterion = 0;     % 0: first vector to be combined
                            % 1: not first vector to be combined
    
    returnedData = [];      % vector to hold returned data from functions
    
    
    %%%%%%%%%%%%%%%%%%% inputStep.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if(stepSize ~= 0)
    
        returnedDataStep = inputStep(u, windowSize, stepSize);
        
        if(firstCriterion == 0)
        
            returnedData = criteriaCombination(returnedDataStep, returnedDataStep);
            firstCriterion = 1;
        
        else
            
            returnedData = criteriaCombination(returnedDataStep, returnedData);
            
        end
        
    end
    
    %%%%%%%%%%%%%%%%%%% meanChange.m U %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if(minMeanChangeU ~= 0)
    
        returnedDataMeanChangeU = meanChange(u, windowSize, minMeanChangeU);
        
        if(firstCriterion == 0)
        
            returnedData = criteriaCombination(returnedDataMeanChangeU, returnedDataMeanChangeU);
            firstCriterion = 1;
        
        else
            
            returnedData = criteriaCombination(returnedDataMeanChangeU, returnedData);
            
        end
        
    end
    
    %%%%%%%%%%%%%%%%%%% meanChange.m Y %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if(minMeanChangeY ~= 0)
    
        returnedDataMeanChangeY = meanChange(y, windowSize, minMeanChangeY);
        
        if(firstCriterion == 0)
        
            returnedData = criteriaCombination(returnedDataMeanChangeY, returnedDataMeanChangeY);
            firstCriterion = 1;
        
        else
            
            returnedData = criteriaCombination(returnedDataMeanChangeY, returnedData);
            
        end
        
    end
    
   
    %%%%%%%%%%%%%%% variance.m U %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if(minVarianceU ~= 0)
    
        returnedDataVarU = variance(u, windowSize, minVarianceU);
        
        if(firstCriterion == 0)
        
            returnedData = criteriaCombination(returnedDataVarU, returnedDataVarU);
            firstCriterion = 1;
        
        else
            
            returnedData = criteriaCombination(returnedDataVarU, returnedData);
            
        end
        
    end
    
    %%%%%%%%%%%%%%%%%% variance.m Y %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if(minVarianceY ~= 0)
    
        returnedDataVarY = variance(y, windowSize, minVarianceY);
        
        if(firstCriterion == 0)
        
            returnedData = criteriaCombination(returnedDataVarY, returnedDataVarY);
            firstCriterion = 1;
        
        else
            
            returnedData = criteriaCombination(returnedDataVarY, returnedData);
            
        end
        
    end
    
    
    %%%%%%%%%%%%%% meanVariance.m U %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    if(minMeanVarU ~= 0)
    
        returnedDataMeanVarU = meanVariance(u, windowSize, minMeanVarU);
        
        if(firstCriterion == 0)
        
            returnedData = criteriaCombination(returnedDataMeanVarU, returnedDataMeanVarU);
            firstCriterion = 1;
        
        else
            
            returnedData = criteriaCombination(returnedDataMeanVarU, returnedData);
            
        end
        
    end
    
     %%%%%%%%%%%%%% meanVariance.m Y %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    if(minMeanVarY ~= 0)
    
        returnedDataMeanVarY = meanVariance(y, windowSize, minMeanVarY);
        
        if(firstCriterion == 0)
        
            returnedData = criteriaCombination(returnedDataMeanVarY, returnedDataMeanVarY);
            firstCriterion = 1;
        
        else
            
            returnedData = criteriaCombination(returnedDataMeanVarY, returnedData);
            
        end
        
    end
    
    %%%%%%%%%%%%%% segmentSelect.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    sysIdSegmentU = [];
    sysIdSegmentY = [];
    valSegmentU = [];
    valSegmentY = [];

    [sysIdSegmentU, sysIdSegmentY, valSegmentU, valSegmentY] = segmentSelect(u, y, returnedData);
    
   
    
    